/* (C) 2011 Yana */

#define Y_PREPROCESS_ONLY
#include "y_yanamips.h"
#include "yanamips.h"

	.text
	.balign 4
	.set at
	.set reorder

#if !defined(__GNUC__)

	.global y_yanamips_read_badvaddr
y_yanamips_read_badvaddr:
	mfc0 $2, YANAMIPS_BADVADDR
	jr $ra

	.global y_yanamips_read_cause
y_yanamips_read_cause:
	mfc0 $2, YANAMIPS_CAUSE
	jr $ra

	.global y_yanamips_read_epc
y_yanamips_read_epc:
	mfc0 $2, YANAMIPS_EPC
	jr $ra

	.global y_yanamips_read_status
y_yanamips_read_status:
	mfc0 $2, YANAMIPS_STATUS
	jr $ra

	.global y_yanamips_syscall
y_yanamips_syscall:
	syscall
	jr $ra

	.global y_yanamips_write_badvaddr
y_yanamips_write_badvaddr:
	mtc0 $4, YANAMIPS_BADVADDR
	YANAMIPS_HAZARD_BADVADDR
	jr $ra

	.global y_yanamips_write_cause
y_yanamips_write_cause:
	mtc0 $4, YANAMIPS_CAUSE
	YANAMIPS_HAZARD_CAUSE
	jr $ra

	.global y_yanamips_write_epc
y_yanamips_write_epc:
	mtc0 $4, YANAMIPS_EPC
	YANAMIPS_HAZARD_EPC
	jr $ra

	.global y_yanamips_write_status
y_yanamips_write_status:
	mtc0 $4, YANAMIPS_STATUS
	YANAMIPS_HAZARD_STATUS
	jr $ra

#endif
